-- TODO: Update account name. 
select strftime('%Y', TRANSDATE) as YEAR
    , strftime('%m', TRANSDATE) as MONTH
    , '' as DATE
    , total(TRANSAMOUNT)
        + (select INITIALBAL + total(TRANSAMOUNT)
            from
                (select ACCOUNTID, TRANSDATE, STATUS,
                    (case when TRANSCODE = 'Deposit' then TRANSAMOUNT else -TRANSAMOUNT end) as transamount
                from CHECKINGACCOUNT_V1
                union all
                select TOACCOUNTID, TRANSDATE, STATUS, TOTRANSAMOUNT 
                from CHECKINGACCOUNT_V1
                where TRANSCODE = 'Transfer') t2
            where t2.ACCOUNTID = t1.ACCOUNTID
                and t2.STATUS <> 'V'
                and (strftime('%Y', t2.TRANSDATE) < strftime('%Y', t1.TRANSDATE)
                    or (strftime('%Y', t2.TRANSDATE) = strftime('%Y', t1.TRANSDATE)
                        and strftime('%m', t2.TRANSDATE) < strftime('%m', t1.TRANSDATE)))
        ) as Balance
from
    (select ACCOUNTID, TRANSDATE, STATUS,
        (case when TRANSCODE = 'Deposit' then TRANSAMOUNT else -TRANSAMOUNT end) as transamount
    from CHECKINGACCOUNT_V1
    union all
    select TOACCOUNTID, TRANSDATE, STATUS, TOTRANSAMOUNT 
    from CHECKINGACCOUNT_V1
    where TRANSCODE = 'Transfer') t1
inner join ACCOUNTLIST_V1 a on a.ACCOUNTID = t1.ACCOUNTID
where ACCOUNTNAME = 'Account1'
    and t1.STATUS <> 'V'
group by YEAR, MONTH
order by YEAR asc, MONTH asc;
